program Project2Levels;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, VCL.FlexCel.Core, FlexCel.XlsAdapter, FlexCel.Report, Generics.Collections;

type
   TProduct = Class
    public
      ProductNr: Integer;
      Name: String;
   end;
   OrderItem = Class
   public
     OrderItemNr: Integer;
     ProductList: TList<TProduct>;
   end;

   TOrder = Class
   public
     OrderNr: Integer;
     OrderItem: TList<OrderItem>
   end;

   TEmployee = class
   public
     FirstName: string;
     LastName: string;
     Orders: TList<TOrder>;
  end;


var
  fr: TFlexCelReport;
  Employees: TList<TEmployee>;
  Employee: TEmployee;
  Order: TOrder;
  orderItm: OrderItem;
  prod: TProduct;
begin
  Employees := TList<TEmployee>.Create;
  Employee := TEmployee.Create;
  Employee.FirstName := 'Adrian';
  Employee.Orders := TList<TOrder>.Create;
  Order := TOrder.Create;
  Order.OrderNr := 3;
  Order.OrderItem := TList<OrderItem>.Create;
  Employee.Orders.Add(Order);
  Employees.Add(Employee);

  OrderItm := OrderItem.Create;
  Order.OrderItem.Add(OrderItm);

  OrderItm.OrderItemNr:=6;
  orderItm.ProductList := TList<TProduct>.Create;
  Prod := TProduct.Create;
  OrderItm.ProductList.Add(Prod);
  Prod.ProductNr := 9;
  Prod.Name := 'hi';



  fr := TFlexCelReport.Create(true);
  try
     fr.AddTable<TEmployee>('Employee', Employees);
     fr.Run('..\..\template.xlsx', '..\..\result.xlsx');
  finally
    fr.Free;
  end;

end.
